% G_ECG_CLASSIFICATION - ECG Heartbeat Classification Framework.
% 
% Performs the steps of the classification starting from the entry point
% defined in G_INIT.
% 
% Copyright (C) 2018 ELTE IK NumAnal, GNU GPL 3

%% 0. Initialization
fprintf('0. Initialization\n');
g_init;
G_ENTRY = str2double(getenv('G_ENTRY'));

%% 1. Data conversion and preprocessing
if G_ENTRY <= 1
    fprintf('1. Data conversion and preprocessing\n');
    g_data;
end

%% 2. Feature extraction
if G_ENTRY <= 2
    fprintf('2. Feature extraction\n');
    g_feat;
end

%% 3. Classification
if G_ENTRY <= 3
    fprintf('3. Classification\n');
    g_class;
end

%% 4. Final fusion
if G_ENTRY <= 4
    fprintf('4. Final fusion\n');
    g_final;
end
