% G_CLASS_MAT - Accuracy and confusion matrix for classification result.
% 
% Calculates the accury and the confusion matrix for a classification result
% using the grund truth labels.
% 
% Copyright (C) 2018 ELTE IK NumAnal, GNU GPL 3

function [acc, mat] = g_class_mat(classes, test_classes, mat_size)
    if isempty(mat_size)
        CC = unique([classes(:); test_classes(:)]);
        mat_size = length(CC);
        
        classes0 = classes;
        test_classes0 = test_classes;
        for k = 1:mat_size
            classes(classes0 == CC(k)) = k;
            test_classes(test_classes0 == CC(k)) = k;
        end
    end
    % confusion matrix
    mat = zeros(mat_size);
    for k = 1:length(test_classes)
        mat(test_classes(k), classes(k)) = mat(test_classes(k), classes(k)) + 1;
    end
    % accuracy
    acc = trace(mat) / length(test_classes) * 100;
end
