% G_DATA_CONVERT - Data conversion to MAT format.
% 
% See also G_DATA.
% 
% Copyright (C) 2018 ELTE IK NumAnal, GNU GPL 3

function g_data_convert(path_src)
    %% data folders
    path_data = '00_original';
    path_atr = '00_original';
    % create folders
    g_data_save_mkdir(['data', filesep, path_data]);
    g_data_save_mkdir(['atr', filesep, path_atr]);
    %% load and save list of records
    reclist = {};
    f = fopen([path_src, filesep, 'RECORDS'], 'r');
    if f ~= -1
        line = fgetl(f);
        while ischar(line)
            reclist = [reclist; line];
            line = fgetl(f);
        end
        fclose(f);
    else
        error('RECORDS file not found');
    end
    g_data_save_reclist(reclist);
    %% load and save records and annotations
    for rec = 1:length(reclist)
        fprintf('  %s\n', reclist{rec});
        % record data
        [signal, fa] = rdsamp([path_src, filesep, reclist{rec}]);
        g_data_save_signal(reclist{rec}, path_data, signal, fa);
        % annotations
        [loc, ann] = rdann([path_src, filesep, reclist{rec}], 'atr');
        g_data_save_atr(reclist{rec}, path_atr, loc(:)', ann(:)');
    end
    %% fix record 114
    [signal, fa] = g_data_load('114', path_data, path_atr);
    signal = signal(:, 2:-1:1);
    g_data_save_signal('114', path_data, signal, fa);
end
