% G_DATA_LOAD - Load a record.
% 
% Loads a record of the database (signal and annotations) from
% [G_OUTPUT]/mitdb. See also G_DATA.
% 
% Copyright (C) 2018 ELTE IK NumAnal, GNU GPL 3

function [signal, fa, loc, cls] = g_data_load(sample, data, atr)
    %% load signal of specified type
    if isempty(data)
        data = '00_original';
    end
    s = load([getenv('G_OUTPUT'), filesep, 'mitdb', filesep, 'data', filesep, data, filesep, sample, '.mat']);
    signal = s.signal;
    fa = s.fa;
    %% load annotations of specified type
    if isempty(atr)
        atr = '00_original';
    end
    a = load([getenv('G_OUTPUT'), filesep, 'mitdb', filesep, 'atr', filesep, atr, filesep, sample, '.mat']);
    loc = a.loc;
    cls = a.cls;
end
