% G_FEAT_RR - RR interval features.
% 
% Copyright (C) 2018 ELTE IK NumAnal, GNU GPL 3

function rr_feat = g_feat_rr(loc, fa, norm)
    loc = loc(:);

    n_local = 10 * fa;
    n_avg = 5 * 60 * fa;
    rr_local = zeros(size(loc));
    rr_avg = zeros(size(loc));
    for i = 1:length(loc)
        rr_local(i) = rr_window(loc, i, n_local);
        rr_avg(i) = rr_window(loc, i, n_avg);
    end

    rr = diff(loc);
    rre = [0; rr; 0];

    rr_feat = [rre(1:end-1) rre(2:end) rr_local rr_avg];
    if norm
        rr_feat = rr_feat ./ mean(rr);
    end
end

function rr_mean = rr_window(loc, i, n)
    beatmask = loc(1:i) >= (loc(i) - n);
    rr = diff(loc(beatmask));
    if isempty(rr)
        rr_mean = 0;
    else
        rr_mean = mean(rr);
    end
end
