% G_FEAT_SETS - Split heartbeats into training and testing sets.
% 
% Copyright (C) 2018 ELTE IK NumAnal, GNU GPL 3

function [train_beats, test_beats, train_classes, test_classes] = g_feat_sets(labels)
    %% beat classes
    classes = 'NLRAV/a!FxjfEJeQ';
    class_ratio = 0.5 * ones(1, 16);
    class_ratio(1) = 0.13;  % N
    class_ratio(2:6) = 0.4; % LRAVP

    %% train/test sets
    train_beats = [];
    test_beats = [];
    train_classes = [];
    test_classes = [];

    rng(0);
    NN = 0;
    NN_train = 0;
    for c = 1:length(classes)
        beats = find(labels == classes(c));
        N = length(beats);
        P = randperm(N);
        N_train = ceil(N * class_ratio(c));

        train_beats = [train_beats beats(P(1:N_train))];
        test_beats = [test_beats beats(P(N_train+1:end))];
        train_classes = [train_classes (zeros(1, N_train) + c)];
        test_classes = [test_classes (zeros(1, N-N_train) + c)];
        
        fprintf('  %s   %d\t%d\t%d\n', classes(c), N, N_train, N-N_train);
        NN = NN + N;
        NN_train = NN_train + N_train;
    end
    fprintf('  SUM %d\t%d\t%d\n', NN, NN_train, NN-NN_train);
end
