% G_PREPROC_FILTER - Preprocessing the signal.
% 
% Baseline removal and low-pass filtering.
% 
% Copyright (C) 2018 ELTE IK NumAnal, GNU GPL 3

function g_preproc_filter
    path_filtered = '01_filter';
    g_data_save_mkdir(['data', filesep, path_filtered]);
    reclist = g_data_load_reclist;
    for rec = 1:length(reclist)
        fprintf('  %s\n', reclist{rec});
        [signal, fa] = g_data_load(reclist{rec}, [], []);
        % level for baseline
        level = ceil(log2(fa)) - 1;
        % filter for filtering
        d = designfilt('lowpassfir', 'FilterOrder', 12, 'HalfPowerFrequency', 35 / (fa / 2));
        
        for l = 1:size(signal, 2)
            % baseline
            [C, L] = wavedec(signal(:, l), level, 'sym10');
            baseline = wrcoef('a', C, L, 'sym10', level);
            signal(:, l) = signal(:, l) - baseline;
            % filtering
            %  signal(:, l) = filtfilt(d, signal(:, l));
            h = d.Coefficients;
            s = [signal(:, l); zeros(6, 1)];
            s = filter(h, 1, s);
            signal(:, l) = s(6+1:end);
        end
        g_data_save_signal(reclist{rec}, path_filtered, signal, fa);
    end
end
